import java.io.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.*;

class Feature {

    String feature_name;
    String first_choice;
    String default_status;
    Vector values;
    boolean has_been_used;

    //Constructor
    public Feature (String fn, String df, String ds, Vector val) {	
	feature_name = fn;
	first_choice = df;
	default_status = ds;
	values = val;
	has_been_used = false;

	System.out.println(toString());
    }

    public void is_Used() { has_been_used = true; }

    public void reset() { has_been_used = false; }

    public String toString() {
	String s = "feature name: " + feature_name + "\n";
	s = s + "default: " + first_choice + "\n";
	s = s + "values: ";

	for (int a=0; a < values.size(); a++) {
	    s =  s + ((String) values.get(a)); 
	}
	s = s + "\n";

	return s;
    }
}

public class multiply2 {

    static Hashtable fvd; //the feature value database
    static Vector feature_structures = new Vector();  //the set of complete feature structures
    static Vector exclusions; //Feature/Value combinations that are not allowed
    static Vector requirements; //Feature/Value combinations that are required

    //Loads a generic file
    public static Vector load(String filename) {
        Vector read_in = new Vector();

	try{

	    //Open file for reading
	    FileReader fr = new FileReader (filename);
	    LineNumberReader lr = new LineNumberReader (fr);

	    int lineCount = 0;  //The counter for lines
	    boolean eof = false;  //End of File Flag

	    //Read file line by line
	    while (!eof){
		//read line to string
		String line = lr.readLine();

		if (line == null){
		    eof = true;
		}
		else {
		    read_in.add(line.trim());
		}
	    }
	}
	catch (IOException e) {
	    System.out.println ("Cannot open file!! " + e);
	    System.exit(0);
	    
	}
	return read_in;
    }


    //multiply the feature structures according to the specification
    public static Vector multiply_out (Vector multiply_spec) {

	feature_structures = new Vector();

	for (int n=0; n < multiply_spec.size(); n++) {
	    //Add unspecified default values
	    String to_modify = (String) multiply_spec.get(n);
	    String full_spec = "";

	    to_modify = replaceAllWithValues(to_modify);
	    System.out.println("***********\n" + to_modify + "************");
	    
	    while(to_modify.indexOf("))") > -1) {
		//Separate the spec into clauses
		String current_clause = to_modify.substring(0, to_modify.indexOf("))") + 1);
		
		//Find all of the specified values
		StringTokenizer st6 = new StringTokenizer(current_clause, "(");
		Vector feature_collection = new Vector(); //List of features specified
		Vector feature_type = new Vector();  //The overall type (i.e. 'c', 'np') associated with each feature
		while (st6.hasMoreTokens()) {
		    String next_fvp = st6.nextToken();
		    StringTokenizer st7 = new StringTokenizer(next_fvp);
		    if (st7.hasMoreTokens()){
			String next_feature = st7.nextToken();
			feature_collection.add(next_feature);
			StringTokenizer st5 = new StringTokenizer(next_feature, "-");
			feature_type.add(st5.nextToken());
		    }
		}
	    
		//Check collected names against fvd
		Vector temp_fvd = new Vector(fvd.values());
		for (int b=0; b < temp_fvd.size(); b++) {
		    boolean is_specified = false;
		    Feature fvd_entry = (Feature) temp_fvd.get(b);
		    String fvd_feature = fvd_entry.feature_name;
		    for (int c=0; c < feature_collection.size(); c++) {
			String spec_entry = (String) feature_collection.get(c);
			if (spec_entry.equals(fvd_feature)) {
			    is_specified = true;
			    break;
			}
		    }
		    
		    if (!is_specified) {
			//fill in unspecified values
			boolean right_category = false;
			StringTokenizer st8 = new StringTokenizer(fvd_feature, "-");
			String category = st8.nextToken();
			
			for (int d=0; d < feature_type.size(); d++) {			
			    if (category.equals(feature_type.get(d))) {
				right_category = true;
			    }
			}
			if (right_category) {
			    if (fvd_entry.default_status.equals("default")) {
				current_clause =  current_clause + "(" + fvd_feature + " " + fvd_entry.first_choice +")";
			    }
			}
		    }
		}
		String truncate = to_modify.substring(to_modify.indexOf("))")+1);
		StringTokenizer st9 = new StringTokenizer(truncate, "(");
		full_spec = full_spec + current_clause + st9.nextToken();
		if ((to_modify.indexOf("))") < to_modify.length()-2)) {
		    to_modify = to_modify.substring(to_modify.indexOf("))") + 3, to_modify.length());
		}
		else {to_modify = "";}
		
	    }

	    Vector part_feature_structures = new Vector(100000);
	    StringTokenizer st = new StringTokenizer(full_spec, "(");
	    part_feature_structures.add(full_spec);
	    
	    //Step through each feature value pair and expand
	    while (st.hasMoreTokens()) { 
		
		//Search through parenthesis and find a feature-value pair
		String toProcess = st.nextToken();
	    
		if (toProcess.trim().length() > 0) {
		    
		    StringTokenizer st2 = new StringTokenizer(toProcess, ")");
		    while (st2.hasMoreTokens()) {
			String toReplace = st2.nextToken();
			//System.out.println("To Replace: " + toReplace);
			if ((toReplace.trim().length() > 0) && (toReplace.trim().indexOf(' ') > -1)) {
			    Vector new_combinations = new Vector(100000);
			    for (int a=0; a < part_feature_structures.size(); a++) {
				StringTokenizer st3 = new StringTokenizer(toReplace);
				String type = st3.nextToken().trim();
				
				//make sure feature name is in database
				StringBuffer current_fs = new StringBuffer(part_feature_structures.get(a).toString());
				
				while (st3.hasMoreTokens()) {
				    current_fs = new StringBuffer(part_feature_structures.get(a).toString());
				    String next = st3.nextToken();
				    
				    int start_of_replace = 0;
				    if (current_fs.length() > 1000) {
					for (int q=0; q < current_fs.length()-1000; q++) {
					    String slice = current_fs.substring(q, q + 1000);
					    if (slice.indexOf(toReplace) > -1) {
						start_of_replace = slice.indexOf(toReplace) + q;
						break;
					    }
					}
				    }
				    else {
					String check = current_fs.toString();
					start_of_replace = check.indexOf(toReplace);
				    }
				    int end_of_replace = start_of_replace + toReplace.length();
				    StringBuffer to_add = new StringBuffer(3500);
				    to_add.append(current_fs.substring(0, start_of_replace) + type + " " + next);
				    
				    boolean kosher = meetsExclusions(current_fs.toString());
				    
				    if (kosher) {
					StringBuffer replacement = new StringBuffer();
					replacement.append(current_fs);
					    to_add.append(replacement.delete(0, end_of_replace));
					    new_combinations.add(to_add);
				    }
				}   			
			    }
			    part_feature_structures.removeAllElements();
			    //Vector checked_new_combinations = new Vector();
			    //for (int p=0; p < new_combinations.size(); p++) {
			    //	StringBuffer to_check_fs = (StringBuffer) new_combinations.get(p);
			    // 	if (meetsRequirements(to_check_fs.toString())) {
			    // 	    checked_new_combinations.add(to_check_fs);
			    //	}
			    //}
			    //System.out.println("^^^^^\n" + new_combinations);
			    part_feature_structures.addAll(new_combinations);
			}
		    }
		}
	    }

	    //part_feature_structures.removeAllElements();
	    Vector checked_new_combinations = new Vector();
	    for (int p=0; p < part_feature_structures.size(); p++) {
		StringBuffer to_check_fs = (StringBuffer) part_feature_structures.get(p);
		if (meetsRequirements(to_check_fs.toString())) {
		    checked_new_combinations.add(to_check_fs);
		}
	    }
	    part_feature_structures.removeAllElements();
	    part_feature_structures.addAll(checked_new_combinations);

	    part_feature_structures = sample(part_feature_structures);
	    feature_structures.add(part_feature_structures);
	}
	return feature_structures;
    }

    public static String replaceAllWithValues(String multiply) {

	String toReplaceAll = multiply;
	while (toReplaceAll.indexOf("#all") != -1) {
	    
	    //Go to first instance of #all
	    int find_all = toReplaceAll.indexOf("#all");

	    //slice by location of #all
	    String slice = toReplaceAll.substring(0, find_all);

	    //pull off feature name by last open paren
	    int lastParen = slice.lastIndexOf("(");
	    String feature_name = toReplaceAll.substring(lastParen + 1, find_all).trim();
		
	    //get list of values
	    Feature feature_needed = (Feature) fvd.get(feature_name);
	    if (feature_needed != null) {
		String value_list = "";
		
		for (int d=0; d < feature_needed.values.size(); d++){
		    value_list = value_list + " " +(String) feature_needed.values.get(d);
		}
		System.out.println("VALUES: " + value_list);
		//replace #all with spaced feature list
		toReplaceAll = toReplaceAll.replaceFirst("#all", value_list.trim());
	    }
	    else {
		//add error if feature is not found
		toReplaceAll = toReplaceAll.replaceFirst("#all", "FEATURE NOT IN DATABASE");
	    }
	}
	return (toReplaceAll);
    }


    public static String replacePointers(String current_fs) {

        String toReplacePointer = current_fs;
        while (toReplacePointer.indexOf("#") != -1) {

            //Go to first instance of #<pointer>
            int find_pointer = toReplacePointer.indexOf("#");

            //slice by location of #<pointer>
            String front_slice = toReplacePointer.substring(0, find_pointer);
	    String back_slice = toReplacePointer.substring(find_pointer, toReplacePointer.length());

            //pull off feature name by last open paren
            int lastOpenParen = front_slice.lastIndexOf("(");
	    int lastCloseParen = back_slice.indexOf(")") + front_slice.length();
            String feature_name = toReplacePointer.substring(lastOpenParen + 1, find_pointer).trim();

	    //find path in FS by splicing pointer name
	   
	    String feature_path = toReplacePointer.substring(find_pointer + 1, lastCloseParen).trim();
	    System.out.println("Feature Path: " + feature_path);

	    StringTokenizer st = new StringTokenizer(feature_path, "-");
	    String fs_section = current_fs;

	    while (st.hasMoreTokens()){
		String current_label = st.nextToken();
		System.out.println("current label: " + current_label);
		//Find the current label in the tree and slice off level
		fs_section = fs_section.substring(fs_section.indexOf("(" + current_label) , fs_section.length());
	    }

	    //find the first instance of the feature and save the value
	    int end_of_feature = fs_section.indexOf(feature_name) + feature_name.length();
	    String needed_value = fs_section.substring(end_of_feature, fs_section.indexOf(")", end_of_feature));
	    System.out.println("Needed value: " + needed_value);

	    //replace #<pointer> with found value
	    toReplacePointer = toReplacePointer.replaceFirst("#" + feature_path, needed_value);
        }
        return (toReplacePointer);
    }


    public static boolean meetsExclusions(String current_fs) {

	boolean is_valid = true;
	for (int p=0; p < exclusions.size(); p++) {
	    Vector currentForbidden = (Vector) exclusions.get(p);
	    if (currentForbidden.indexOf(";;") == -1) {
		//check to see if the exclusions will be on the same level
                boolean same_prefix = isSamePrefix(currentForbidden);

                String [] levels;
                //split into levels
                if (same_prefix){
                    levels = splitFS(current_fs);
                }
                //or don't ***NEED TO MODIFY TO JUST UP OR DOWN ONE LEVEL***
                else {
                    levels = new String[1];
		    levels[0] = current_fs;
                }
		for (int h=0; h < levels.length; h++) {
		    if (isFound(currentForbidden, levels[h])) {
			is_valid = false; 
			
			System.out.println("Removed " + current_fs + "\n1 because of" + currentForbidden);
		    }
		}
	    }
	}
	return is_valid;
    }

    public static boolean meetsRequirements(String current_fs) {

	boolean is_valid = true;
        for (int q=0; q < requirements.size(); q++) {
	    Vector currentNeeded = (Vector) requirements.get(q);
	    if (currentNeeded.indexOf(";;") == -1) {
		//check to see if the requirements will be on the same level
		boolean same_prefix = isSamePrefix(currentNeeded);

		String [] levels;
		//split into levels
		if (same_prefix){
		    levels = splitFS(current_fs); 
		}
		//or don't ***NEED TO MODIFY TO JUST UP OR DOWN ONE LEVEL***
		else {
		    levels = new String[1];
		    levels[0] = current_fs;
		}

		//the first feature is the master feature
		//if not found, then ignore everything
		String master_feature = currentNeeded.get(0).toString();
		for (int g=0; g < levels.length; g++) {
		    if (levels[g].indexOf(master_feature) > 0) {
			boolean result = isFound(currentNeeded, levels[g]);
			if (!containsSample(currentNeeded, levels[g])){
			    if (!result) {
				is_valid = false;
				//System.out.println(levels[g]);
				System.out.println("Removed " + current_fs + "\n2 because of" + currentNeeded);
			    }
			}
		    }
		}
	    }
        }

	//if (is_valid) System.out.println("SAVED: " + current_fs);

	return is_valid;
    }

    public static boolean containsSample(Vector current_combination, String sample_fs){
	boolean hasSample = false;

	for (int h=0; h < current_combination.size(); h++) {
	    //pull off feature name
	    String temp_set = (String) current_combination.get(h);
	    String feature_name = temp_set.substring(temp_set.indexOf("(")+1, temp_set.indexOf(" "));
	    //System.out.println("FN***: " + feature_name);
	    if (sample_fs.indexOf(feature_name + " " + "#sample") > -1) {
		hasSample = true;
		System.out.println("Has Sample?: " + hasSample);
	    }
	}
	return hasSample;
    }

    public static boolean isSamePrefix(Vector current_combination){
	boolean same_prefix = true;
        String lastPrefix = "";

        //Check to see if the restrictions have the same prefix
        for (int e=0; e < current_combination.size(); e++) {
            if (current_combination.size() > 1) {
                //pull off the prefix
                String tempString = (String) current_combination.get(e);
                String prefixString = tempString.substring(1, tempString.indexOf("-")).trim();
                //System.out.println("Prefix: " + prefixString);
                //compare to last prefix
                if ((lastPrefix.length() != 0) && (!lastPrefix.equals(prefixString))){
                    same_prefix = false;
                }
                lastPrefix = prefixString;
            }
        }
        //System.out.println("Same?: " + same_prefix);
	return same_prefix;
    }

    public static String[] splitFS(String toSplit) {
	//chop by levels
	String[] levelSet = toSplit.split("\\){3}?|\\({2}?");
	return levelSet;
    }

    public static boolean isFound(Vector current_combination, String current_fs) {

	boolean all_found = true;
	boolean same_prefix = isSamePrefix(current_combination);
	//***kluge to replace thrown away parens
	String fs_repaired = "(" + current_fs + ")";

	for (int f=0; f < current_combination.size(); f++) {
	    String tempString = ((String) current_combination.get(f));
	    if (fs_repaired.indexOf(tempString) < 0) {

		all_found = false;
		break;
	    }
	}
	return all_found;
    }

    public static Vector sample(Vector to_add_sample) {
	System.out.println("$$$$$ sample! $$$$$");
	Vector modified = new Vector();
	Random random_value_maker = new Random();
	for (int a=0; a < to_add_sample.size(); a++) {
	    StringBuffer current_fs = new StringBuffer(to_add_sample.get(a).toString().toLowerCase());
	    StringBuffer new_fs = new StringBuffer();
	    StringBuffer original_fs = new StringBuffer();
	    if (current_fs.indexOf("#sample") == -1) {
		new_fs = current_fs;
	    }
	    else {
		original_fs = new StringBuffer(current_fs.toString());
	    }

	    boolean pass = false;
	    while (!pass) {
		while (current_fs.indexOf("#sample") != -1) {
		    
		    //Find next #sample
		    int sample_start = current_fs.indexOf("#sample");
		    
		    //find corresponding feature name
		    String fs_part = (String) current_fs.subSequence(0, sample_start);
		    int last_open_paren = fs_part.lastIndexOf("(");
		    String name = (String) fs_part.subSequence(last_open_paren+1, sample_start-1);
		    //System.out.println("FEATURE: " + name);		
		    
		    //find feature list
		    Feature feature_name = (Feature) fvd.get(name.trim());
		    System.out.println("NAME: " + name);
		    int random_value = random_value_maker.nextInt(feature_name.values.size());
		    System.out.println("RANDOM: " + random_value + " of: " + feature_name.values.size());
		    String next = (String) feature_name.values.get(random_value);
		    //System.out.println("NEW VALUE: " + next);
		    new_fs = current_fs.replace(sample_start, sample_start + "#sample".length(), next);
		    if (!meetsExclusions(new_fs.toString())){
			new_fs = current_fs;
		    }
		}
		//replace pointers
		new_fs = new StringBuffer(replacePointers(new_fs.toString()));
		//one last check for exclusion errors
		if (!meetsExclusions(new_fs.toString())){
		    System.out.println("*******FAILED ON POINTERS!******");
		}
		//check for errors
		else if (meetsRequirements(new_fs.toString())){
		    pass = true;
		    //System.out.println("*******PASSED!******");
		}
		else {
		    //if found reset
		    current_fs = new StringBuffer(original_fs.toString());
		    System.out.println("^^^" + original_fs);
		    System.out.println("*******FAILED!******");
		}
	    }
	    System.out.println("*******ADDED!******");
	    modified.add(new_fs);
	    //System.out.println(modified.size());
	}
	return modified;
    }

    public static void load_restrictions (String filename) {

	Vector restrict_file = load(filename);
	exclusions = new Vector();
	requirements = new Vector();
	boolean flag = true; //flag for type of restriction

	for (int a=0; a < restrict_file.size(); a++) {
	    StringTokenizer st = new StringTokenizer((String)restrict_file.get(a), "\t");
	    Vector temp_vector = new Vector();
	    while (st.hasMoreTokens()) {
		String temp_token = st.nextToken();
		if (temp_token.equals("####")) {
		    flag = false;
		    System.out.println("CHANGING");
		}
		else { temp_vector.add(temp_token); }
	    }
	    if (flag) { requirements.add(temp_vector); }
	    else { 
		if (temp_vector.size() > 0) {
		    exclusions.add(temp_vector); 
		}
	    }
	}
    }


    public static Vector getFVD() {
	
	Vector fvd_vector = new Vector();
	if (fvd != null) {
	    Collection c = fvd.values();
	    fvd_vector.addAll(c);
	}
  
	return fvd_vector;
    }

    //Loads the feature-value database and defaults
    public static Hashtable load_fvd (String filename) {

	Vector lines = load(filename);
	fvd = new Hashtable();

	//Go through vector of lines to extract features and values
	for (int a=0; a < lines.size(); a++) {
	    String current = (String) lines.get(a);
	    current = current.replace(((char)34), ' ').trim();

	    if (current.indexOf(";;") == -1) {
		StringTokenizer st = new StringTokenizer(current, "\t");

		//Pull off the feature name
		String feature_name = "";
		if (st.hasMoreTokens()) {
		    feature_name = st.nextToken().trim();
		}

		//Pull off the feature name
                String default_status = "";
                if (st.hasMoreTokens()) {
                    default_status = st.nextToken().trim();
                }

		int valueCount = 0;  //Used to set default value
		String first_choice = ""; //The default
		Vector values = new Vector(); //set of feature values

		while (st.hasMoreTokens()){
		    if (valueCount == 0) {
			first_choice =  st.nextToken().trim();
			values.add(first_choice);
		    }		
		    else {  values.add(st.nextToken().trim());  }
		    valueCount++;
		}	
		if (feature_name.length() > 0) {
		    fvd.put(feature_name, new Feature(feature_name, first_choice, default_status, values));
		}
	    }
	}
	return fvd;
    }

    public static void save_generic (String filename, String to_save) {
        try {
            FileWriter fr = new FileWriter (filename, false);
            PrintWriter pw = new PrintWriter (fr, true);
	    pw.println(to_save);
	    System.out.println(to_save);
	    pw.close();
        }
        catch (IOException e) {
            System.out.println ("Cannot open file");
        }
    }

    public static void save (String filename, String multiply) {
	try {
	    FileWriter fr = new FileWriter (filename, false);
            PrintWriter pw = new PrintWriter (fr, true);

	    pw.println("*** START MULTIPLY ***");
	    pw.println(multiply);
	    pw.println("*** END MULTIPLY ***");

	    for (int a=0; a < feature_structures.size(); a++) {
		Vector interior = (Vector) feature_structures.get(a);
		for (int b=0; b < interior.size(); b++) {
		    pw.println("");
		    pw.println("newpair\nsrcsent: \ntgtsent: \naligned: \ncontext: \ncomment:");
		    pw.println("");
		    pw.println(interior.get(b));
		}
	    }
	    pw.close();
	}
	catch (IOException e) {
            System.out.println ("Cannot open file");
        }
    }

    public static void main (String[] argv)
    {
	load_fvd("LDC_features.fvd");
	load_restrictions("restriction.rf");

	String full_multiply = "((NP ((np-function actor undergoer)" +
	    "(np-number num-sg)" + "(np-pronoun-exclusivity #all)" +
	    "(np-noun-type pronoun-type))))";

	Vector v = new Vector();
	v.add(full_multiply);
	Vector test = push.sequence(v);
	for (int a=0; a < test.size(); a++) {
	    System.out.println(a + ": " +test.get(a));
	}

	multiply_out(test);
        System.out.println("Saving partial Copula Spec...");
        save("partial_copula.txt", full_multiply);


    }

}











