import java.io.*;
import java.util.Vector;
import java.awt.*;
import java.applet.*;
import java.awt.event.*; // Needed for ActionListener.
import java.util.*;
import javax.swing.*;

class eGUI extends JFrame implements ActionListener {

    JPanel panel;
    //Labels carrying information on the multiply panel
    JLabel defaultExLabel, defaultFVDLabel, commentLabel;
    JFrame jf, jf2, jf3; //Main multiply, fs_generation, sentence generation
    JComboBox featureCombo, valueCombo;
    JTextArea textArea, textArea4, textAreaEdit1, textAreaGenerate;
    String currentFVD, currentExclusion;

    File currentDirectory = new File("/Volumes/DOCS/Recent Projects");
    String saveName = "";
    String  saveElicitName = "";
    JButton refresh, clear, done, insert_fv, view_window, check_window, ok;
    JButton yes, no, cancel, generate, save_fs, save_elicit;
    JScrollPane jp, jp1, jp2, jp3, jp4;
    boolean loadCheck;  //Whether or not a file has been loaded
    File saveFile;
    Vector featureStructures = new Vector();
    JFileChooser cfchooser;
    String lastSaved = ""; //Keeps track of whether the multiply has been saved

    int actionToTake = 0; /* Keeps track of the action to be taken with the save dialog
			   * 1 = close window
			   * 2 = clear text
			   * 3 = load new text
			   */
    //String currentFVD =  "feature_spec_LDC.txt";
    //String currentExclusion = "exclusions.txt";
    Vector featureSorted = new Vector();  //Alphabetized list of features 
    Vector valueSorted = new Vector(); //Alphabetized list values


    public eGUI(String c_FVD, String c_Ex) {

	currentFVD =  c_FVD;
	currentExclusion = c_Ex;

        //initialize frame components
        JFrame.setDefaultLookAndFeelDecorated(true);
        this.setTitle ("Elicitation Corpus Builder");
        this.setResizable (true);
        this.setSize (700, 700);

        //Add menubar
        JMenuBar menuBar = new JMenuBar();
        this.setJMenuBar(menuBar);

        JMenu file = new JMenu("File");
        JMenu edit = new JMenu("Edit");
        JMenu help = new JMenu("Help");

        menuBar.add(file);
        menuBar.add(edit);
        menuBar.add(help);

	//**Menu Options
	JMenuItem load = new JMenuItem ("Load Multiply");
        load.setMnemonic('L');
        load.addActionListener (this);
        load.setActionCommand("load multiply");
        file.add(load);
        JMenuItem save = new JMenuItem ("Save Multiply");
        save.setMnemonic('S');
        save.addActionListener (this);
        save.setActionCommand("save multiply");
        file.add(save);
        JMenuItem saveAs = new JMenuItem ("Save Multiply As");
        saveAs.setMnemonic('V');
        saveAs.addActionListener (this);
        saveAs.setActionCommand("save multiply as");
        file.add(saveAs);
        JMenuItem new1 = new JMenuItem ("New Multiply");
        new1.setMnemonic('N');
        new1.addActionListener (this);
        new1.setActionCommand("clear");
        file.add(new1);
        file.addSeparator();
	JMenuItem newFVD = new JMenuItem ("New Default FVD");
        newFVD.setMnemonic('D');
        newFVD.addActionListener (this);
        newFVD.setActionCommand("new default fvd");
        file.add(newFVD);
	JMenuItem newEx = new JMenuItem ("New Default Exclusions");
        newEx.setMnemonic('X');
        newEx.addActionListener (this);
        newEx.setActionCommand("new default ex");
        file.add(newEx);
	file.addSeparator();
        JMenuItem exit = new JMenuItem ("Exit");
        exit.setMnemonic('E');
        exit.addActionListener (this);
        exit.setActionCommand("exit");
        file.add(exit);        

	JMenuItem clear_all = new JMenuItem ("Clear");
        clear_all.setMnemonic('L');
        clear_all.addActionListener (this);
        clear_all.setActionCommand("clear");
	KeyStroke ctrlNKeyStroke = KeyStroke.getKeyStroke("control N");
        clear_all.setAccelerator(ctrlNKeyStroke);
        edit.add(clear_all);
	JMenuItem cut = new JMenuItem ("Cut");
        cut.setMnemonic('U');
        cut.addActionListener (this);
	KeyStroke ctrlXKeyStroke = KeyStroke.getKeyStroke("control X");
	cut.setAccelerator(ctrlXKeyStroke);
        cut.setActionCommand("cut");
        edit.add(cut);
	JMenuItem copy = new JMenuItem ("Copy");
        copy.setMnemonic('C');
	KeyStroke ctrlCKeyStroke = KeyStroke.getKeyStroke("control C");
        copy.setAccelerator(ctrlCKeyStroke);
        copy.addActionListener (this);
        copy.setActionCommand("copy");
        edit.add(copy);
	JMenuItem paste = new JMenuItem ("Paste");
        paste.setMnemonic('P');
	KeyStroke ctrlVKeyStroke = KeyStroke.getKeyStroke("control V");
        paste.setAccelerator(ctrlVKeyStroke);
        paste.addActionListener (this);
        paste.setActionCommand("paste");
        edit.add(paste);
	JMenuItem selectAll = new JMenuItem ("Select All");
        selectAll.setMnemonic('A');
	KeyStroke ctrlAKeyStroke = KeyStroke.getKeyStroke("control A");
        selectAll.setAccelerator(ctrlAKeyStroke);
        selectAll.addActionListener (this);
        selectAll.setActionCommand("select all");
        edit.add(selectAll);


	JMenuItem about = new JMenuItem ("About");
        about.setMnemonic('A');
        about.addActionListener (this);
        about.setActionCommand("about");
        help.add(about);

        //Add components to the JFrame
        panel = new JPanel();
        this.getContentPane().add(panel);

        panel.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
        panel.setLayout(new GridLayout(0, 1));

        featureCombo = new JComboBox();
        featureCombo.setToolTipText("Choose the feature");
        featureCombo.setMaximumRowCount(10);
        featureCombo.addActionListener (this);
        featureCombo.setActionCommand("featureCombo");

	valueCombo = new JComboBox();
        valueCombo.setToolTipText("Choose the value");
        valueCombo.setMaximumRowCount(10);
        valueCombo.addActionListener (this);
        valueCombo.setActionCommand("valueCombo");

	insert_fv = new JButton("Insert");
        insert_fv.addActionListener (this);

	Box Box3 = Box.createHorizontalBox();
	Box3.add(featureCombo);
	Box3.add(valueCombo);
	Box3.add(insert_fv);

        textArea = new JTextArea(6, 30);
        textArea.setEditable(true);
	textArea.setLineWrap(true);
        jp = new JScrollPane(textArea);
        jp.setPreferredSize(new Dimension(600, 500));

	//Set up buttons at the bottom for editing
        Box Box2 = Box.createHorizontalBox();
	view_window = new JButton("Get Feature Structures");
        view_window.addActionListener (this);
	check_window = new JButton("Check for Errors");
        check_window.addActionListener (this);
	clear = new JButton("Clear");
        clear.addActionListener (this);

	Box2.add(Box.createGlue());
	Box2.add(clear);
	Box2.add(check_window);
        Box2.add(view_window);
        Box2.add(Box.createGlue());

        Box labelBox = Box.createHorizontalBox();

	//Create Boxes for Content
        Box mainBox1 = Box.createVerticalBox();

	defaultExLabel = new JLabel("Default Exclusion File: " + currentExclusion);
        defaultExLabel.setHorizontalAlignment(SwingConstants.RIGHT);
	defaultFVDLabel = new JLabel("Default FVD File: " + currentFVD);
        defaultFVDLabel.setHorizontalAlignment(SwingConstants.RIGHT);
	
        labelBox.add(defaultExLabel);
	labelBox.add(Box.createGlue());
	labelBox.add(defaultFVDLabel);
        labelBox.add(Box.createGlue());

	Box commentBox = Box.createHorizontalBox();
	commentLabel = new JLabel("Feature/Value Comment: " + "stubbed");
	defaultFVDLabel.setHorizontalAlignment(SwingConstants.LEFT);
	commentBox.add(commentLabel);

        //mainBox1.add(Box.createGlue());
	mainBox1.add(commentBox);
        mainBox1.add(Box.createGlue());
        mainBox1.add(Box3);
        mainBox1.add(Box.createGlue());
        mainBox1.add(jp);
        mainBox1.add(Box.createGlue());
        mainBox1.add(labelBox);
        mainBox1.add(Box.createGlue());
        mainBox1.add(Box2);

	panel.add(mainBox1, "Center");
	alphaFVD();
	setDropDown();

	this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

        this.addWindowListener (new WindowAdapter() {
                public void windowClosing(WindowEvent e) { /*System.exit(0);*/
		    //panel.setVisible(true);
		    actionToTake = 1;
		    areYouSurePane();
		}
            });

	getContentPane().add(panel);
        this.setVisible(true);
    }

    /*This pane will ask the user whether they want to save their work 
     *before performing an action that will delete the multiply 
     */
    public void areYouSurePane() {
        System.out.println("lastSaved: " + lastSaved);
        System.out.println("textArea: " + textArea.getText());
        if (!(lastSaved.equals(textArea.getText()))) {
	    //initialize frame components
	    jf3 = new JFrame();
	    jf3.setTitle ("Save Current Multiply?");
	    jf3.setResizable (true);
	    jf3.setSize (450, 200);

	    JPanel savePanel = new JPanel();
	    savePanel.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
	    savePanel.setLayout(new GridLayout(0, 1));
	    
	    //Set up buttons at the bottom for file management
	    Box Box2 = Box.createHorizontalBox();
	    yes = new JButton("yes");
	    yes.addActionListener (this);
	    no = new JButton("no");
	    no.addActionListener (this);
	    cancel = new JButton("cancel");
	    cancel.addActionListener (this);
	    Box2.add(Box.createGlue());
	    Box2.add(yes);
	    Box2.add(no);
	    Box2.add(cancel);
	    Box2.add(Box.createGlue());
	    
	    JLabel saveCurrentLabel = new JLabel();
	    saveCurrentLabel.setText("Would you like to save the current multiply?");
	    
	    saveCurrentLabel.setHorizontalAlignment(SwingConstants.CENTER);
	    
	    //Create Boxes for Contentd
	    Box messageBox = Box.createVerticalBox();
	    messageBox.add(Box.createGlue());
	    messageBox.add(saveCurrentLabel);
	    messageBox.add(Box.createGlue());
	    messageBox.add(Box2);
	    messageBox.add(Box.createGlue());

	    savePanel.add(messageBox, "Center");
	    
	    this.addWindowListener (new WindowAdapter() {
		    public void windowClosing(WindowEvent e) { System.exit(0); }
		    
		});

	    jf3.getContentPane().add(savePanel);
	    jf3.setVisible(true);
	}
	else { nextAction(actionToTake); }
    }


    public void errorPane(boolean hasErrors) {
        //initialize frame components
        jf2 = new JFrame();
        jf2.setTitle ("Error Checker");
        jf2.setResizable (true);
        jf2.setSize (450, 200);

        JPanel errorPanel = new JPanel();
        errorPanel.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
        errorPanel.setLayout(new GridLayout(0, 1));
    
        //Set up buttons at the bottom for file management
        Box Box2 = Box.createHorizontalBox();
        ok = new JButton("ok");
        ok.addActionListener (this);
	Box2.add(Box.createGlue());
	Box2.add(ok);
	Box2.add(Box.createGlue());

	JLabel errorLabel = new JLabel();
	if (hasErrors) { 
	    errorLabel.setText("A bracket or parenthesis mismatch has been found"); 
	    //view_window.setEnabled(false);
	}
	else { 
	    errorLabel.setText("no errors found"); 
	    view_window.setEnabled(true);
	}

        errorLabel.setHorizontalAlignment(SwingConstants.CENTER);

        //Create Boxes for Content
        Box messageBox = Box.createVerticalBox();
        messageBox.add(Box.createGlue());
        messageBox.add(errorLabel);
        messageBox.add(Box.createGlue());
        messageBox.add(Box2);
        messageBox.add(Box.createGlue());

        errorPanel.add(messageBox, "Center");

        this.addWindowListener (new WindowAdapter() {
                public void windowClosing(WindowEvent e) { System.exit(0); }

            });

        jf2.getContentPane().add(errorPanel);
        jf2.setVisible(true);

    }

    public void generatePane() {
        //initialize frame components
        jf = new JFrame();
        jf.setTitle ("Generated Sentences");
        jf.setResizable (true);
        jf.setSize (700, 600);

        JPanel generatePanel = new JPanel();
        generatePanel.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
        generatePanel.setLayout(new GridLayout(0, 1));

        //Text area for surface string
        textAreaGenerate = new JTextArea(1, 1);
        textAreaGenerate.setEditable(false);
        textAreaGenerate.setLineWrap(true);
        JScrollPane jp1  = new JScrollPane(textAreaGenerate);
        jp1.setPreferredSize(new Dimension(600, 500));

        //Set up buttons at the bottom for file management
        Box Box2 = Box.createHorizontalBox();
        save_elicit = new JButton("Save As Elicitation File");
        save_elicit.addActionListener (this);

        Box2.add(Box.createGlue());
        Box2.add(save_elicit);
        Box2.add(Box.createGlue());
	//Create Boxes for Content
        Box mainBox = Box.createVerticalBox();
        mainBox.add(Box.createGlue());
        mainBox.add(jp1);
        mainBox.add(Box.createGlue());
        mainBox.add(Box2);
        mainBox.add(Box.createGlue());

        generatePanel.add(mainBox, "Center");

        textAreaGenerate.setText("");
        int count = 0;
        for (int b=0; b < featureStructures.size(); b++) {
            count++;
            Vector toGenerate = (Vector) featureStructures.get(b);
            for (int c=0; c < toGenerate.size(); c++) {
		try {
		    String result = socket_test.genkit_contact(toGenerate.get(c).toString()); 
		    textAreaGenerate.append(count + ": " + result + "\n");
		}
		catch (IOException e) { 
		    e.printStackTrace();
		    System.err.println("Couldn't get I/O for the connection");
		}
            }
        }

        this.addWindowListener (new WindowAdapter() {
                public void windowClosing(WindowEvent e) { System.exit(0); }

            });

        jf.getContentPane().add(generatePanel);
        jf.setVisible(true);
    
    }

    public void fsPane(String multiply_spec) {
	//initialize frame components
	jf = new JFrame();
        jf.setTitle ("Feature Structures");
        jf.setResizable (true);
        jf.setSize (700, 600);

        JPanel fsPanel = new JPanel();
	fsPanel.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
        fsPanel.setLayout(new GridLayout(0, 1));

	//Text area for surface string
        textAreaEdit1 = new JTextArea(1, 1);
        textAreaEdit1.setEditable(false);
	textAreaEdit1.setLineWrap(true);
	JScrollPane jp1  = new JScrollPane(textAreaEdit1);
	jp1.setPreferredSize(new Dimension(600, 500));

	//Set up buttons at the bottom for file management
        Box Box2 = Box.createHorizontalBox();
        save_fs = new JButton("Save Feature Structures");
        save_fs.addActionListener (this);
	generate = new JButton("Generate");
        generate.addActionListener (this);
	//generate.setEnabled(false);
	done = new JButton("Done");
        done.addActionListener (this);

        Box labelBox = Box.createHorizontalBox();

        Box2.add(Box.createGlue());
	Box2.add(save_fs);
	Box2.add(generate);
        Box2.add(done);
        Box2.add(Box.createGlue());

        //Create Boxes for Content
	Box mainBox = Box.createVerticalBox();
	mainBox.add(Box.createGlue());
        mainBox.add(jp1);
	mainBox.add(Box.createGlue());
        mainBox.add(Box2);
	mainBox.add(Box.createGlue());

        fsPanel.add(mainBox, "Center");

	//**********add full multiply
	textAreaEdit1.setText("");
	Vector v = new Vector();
	v.add(multiply_spec);
	Vector sequenced = push.sequence(v);
	featureStructures = multiply2.multiply_out(sequenced);
	int count = 0;
	for (int b=0; b < featureStructures.size(); b++) {
	    Vector toPrint = (Vector) featureStructures.get(b);
	    for (int c=0; c < toPrint.size(); c++) {
		count++;
		textAreaEdit1.append(count + ": " + toPrint.get(c).toString() + "\n\n");
	    }
	}

        this.addWindowListener (new WindowAdapter() {
                public void windowClosing(WindowEvent e) { System.exit(0); }

            });
	
        jf.getContentPane().add(fsPanel);
        jf.setVisible(true);
	
    }

    /* The Action listener for the menu and button functions
     */
    public void actionPerformed (ActionEvent e) {
	String command = e.getActionCommand();

	if (command.equals("featureCombo")) {
	    chooseFeature();
	    Graphics g = getGraphics();
	}
	else if (command.equals("valueCombo")) { 
	    Graphics g = getGraphics();
	}
	else if (command.equals("Insert")) {
            chooseValue();
            Graphics g = getGraphics();
        }
	else if (command.equals("Check for Errors")) {
	    String checkForErrors = textArea.getText();
	    boolean hasErrors = push.correct_parens(checkForErrors);
	    errorPane(hasErrors);
        }
	else if (command.equals("cancel")) { jf3.setVisible(false); this.setVisible(true); }
	else if (command.equals("yes")) { 
	    jf3.setVisible(false); 
	    String saveName = saveDialog();
            if (saveName != ""){ 
		multiply2.save_generic(saveName, textArea.getText()); 
	        nextAction(actionToTake);
	    }
	}
	else if (command.equals("no")) {
	    jf3.setVisible(false); 
            nextAction(actionToTake);
        }
	else if (command.equals("exit")) { 
	    actionToTake = 1;
	    areYouSurePane();
	}
	else if (command.equals("ok")) { jf2.setVisible(false); }
	else if (command.equals("select all")) { textArea.selectAll(); }
	else if (command.equals("cut")) { textArea.cut(); }
	else if (command.equals("paste")) { textArea.paste(); }
	else if (command.equals("copy")) { textArea.copy(); }
	else if (command.equals("undo")) { /* undo(); */ }
        else if (command.equals("about")){
            JOptionPane.showMessageDialog(this, "This software was designed for the MILE \n" +
                                           "elicitation project at Carnegie Mellon Univeristy." +
					  "\n\nEmail any problems to nosila@cs.cmu.edu");
        }
	else if (command.equals("Get Feature Structures")) {
	    String checkForErrors = textArea.getText();
	    checkForErrors = checkForErrors.replace('\n', ' ');
            boolean hasErrors = push.correct_parens(checkForErrors);
	    if (hasErrors) {
		errorPane(hasErrors);
	    }
	    else { fsPane(checkForErrors); }
	}
	else if (command.equals("Generate")) {
              generatePane(); 
        }
	else if (command.equalsIgnoreCase("Clear")) {
	    actionToTake = 2;
            areYouSurePane();
	    // textArea.setText ("");
        }
	else if (command.equalsIgnoreCase("Done")) { jf.setVisible(false); }
	else if (command.equalsIgnoreCase("Save Feature Structures")) {
	    String saveName = saveDialog();
            
            if (saveName != null){ multiply2.save(saveName, textArea.getText()); }
	}
	else if (command.equalsIgnoreCase("new default ex")) {
            String loadName = loadDialog();
            File loadFile;

            //The following code has been donated by Erik Peterson and
            //modified by Alison Alvarez
            cfchooser = new JFileChooser();
            cfchooser.setCurrentDirectory(currentDirectory);
            int retVal = cfchooser.showOpenDialog(this);
            if (retVal == JFileChooser.APPROVE_OPTION) {
                loadFile = cfchooser.getSelectedFile();
                loadName = loadFile.getName();
            }

            if (loadName != ""){
                multiply2.load_restrictions(loadName);
		currentExclusion = loadName;
		defaultExLabel.setText("Default Exclusion File:" + currentExclusion);
		Graphics g = getGraphics();
            }
        }
	else if (command.equalsIgnoreCase("new default fvd")) {
            String loadName = "";
            File loadFile;

            //The following code has been donated by Erik Peterson and
            //modified by Alison Alvarez
            cfchooser = new JFileChooser();
            cfchooser.setCurrentDirectory(currentDirectory);
            int retVal = cfchooser.showOpenDialog(this);
            if (retVal == JFileChooser.APPROVE_OPTION) {
                loadFile = cfchooser.getSelectedFile();
                loadName = loadFile.getName();
            }

            if (loadName != ""){
		currentFVD = loadName;
                multiply2.load_fvd(loadName);
		defaultFVDLabel.setText("Default FVD File:" + currentFVD);
		Graphics g = getGraphics();
		alphaFVD();
                setDropDown();
            }
        }
        else if (command.equalsIgnoreCase("load multiply")) {
	    actionToTake = 3;
            areYouSurePane();
	    lastSaved = textArea.getText();
        }
	else if (command.equalsIgnoreCase("save multiply")) {
            if (saveName != ""){ 
		multiply2.save_generic(saveName, textArea.getText());
		lastSaved = textArea.getText();
	    }
	    else {
		saveName = saveDialog();
		if (saveName != ""){ 
		    multiply2.save_generic(saveName, textArea.getText()); 
		    lastSaved = textArea.getText();
		}
	    }
        }
	else if (command.equalsIgnoreCase("save multiply as")) {
            saveName = saveDialog();
            if (saveName != ""){ 
		multiply2.save_generic(saveName, textArea.getText());
		lastSaved = textArea.getText(); 
	    }
        }
    }

    /*Continues a selected action after unsaved data inquiries have been made
     * 1 = close window
     * 2 = clear text
     * 3 = load new text
     */
    private void nextAction(int actionToTake) {
	this.setVisible(true);
	if (actionToTake == 1) {
	    System.exit(0);
	}
	else if (actionToTake == 2) {
	    textArea.setText ("");
	    }
	else if (actionToTake == 3) {
	    String loadName = loadDialog();
	    Vector v = new Vector();
	    
	    if (loadName != ""){
		v = multiply2.load(loadName);
		String temp = "";
		for (int f=0; f < v.size(); f++) {
		    temp = temp + (String) v.get(f) + "\n";
		}
		textArea.setText(temp);
	    }
	}	
    }

    private String saveDialog() {
	String saveName = "";
	//The following code has been donated by Erik Peterson and
	//modified by Alison Alvarez
	cfchooser = new JFileChooser();
	cfchooser.setCurrentDirectory(currentDirectory);
	int retVal = cfchooser.showSaveDialog(this);
	if (retVal == JFileChooser.APPROVE_OPTION) {
	    saveFile = cfchooser.getSelectedFile();
	    saveName = saveFile.getName();
	}
	return saveName;
    }

    private String loadDialog() {
	String loadName = "";
	File loadFile;
	
	//The following code has been donated by Erik Peterson and
	//modified by Alison Alvarez
	cfchooser = new JFileChooser();
	cfchooser.setCurrentDirectory(currentDirectory);
	int retVal = cfchooser.showOpenDialog(this);
	if (retVal == JFileChooser.APPROVE_OPTION) {
	    loadFile = cfchooser.getSelectedFile();
	    loadName = loadFile.getName();
	}
	return loadName;
    }

    //A command to alphabetize a loaded feature-value database
    private void alphaFVD() {
	Vector fvd_local = multiply2.getFVD();

	Vector featureToSort = new Vector();
	Vector valueToSort = new Vector();

	for (int f=0; f < fvd_local.size(); f++) {
	    Feature this_feature = (Feature) fvd_local.get(f);
	    String temp = this_feature.feature_name;
	    //System.out.println("&*&*&" + temp);
	    featureToSort.add(temp);
	    
	    for (int g=0; g < this_feature.values.size(); g++) {
		valueToSort.add(this_feature.values.get(g));
		//valueCombo.addItem(this_feature.values.get(g));
	    }
	}

	featureSorted = alphabetize(featureToSort);
	valueSorted = alphabetize(valueToSort);
    }

    //A general alphabetiziong function
    private Vector alphabetize(Vector toAlpha){

	Vector sorted = new Vector();

	for (int j=0; j < toAlpha.size(); j++) {
	    int new_location = 0;
	    String comparison = (String) toAlpha.get(j);

	    for (int k=0; k < sorted.size(); k++) {
		if (comparison.compareTo(sorted.get(k)) < 0) {
		    break;
		}
		else { new_location++;}
	    }

	    int current_size = sorted.size();
	    sorted.setSize(current_size + 1);
	    for (int l= current_size; l > new_location; l--) {
		sorted.setElementAt(sorted.get(l-1), l);
	    }
	    sorted.setElementAt(comparison, new_location);
	}
	return sorted;
    }

    void setDropDown() {
	featureCombo.removeAllItems();
	featureCombo.addItem("display all values");
	valueCombo.removeAllItems();

	for (int h=0; h < featureSorted.size(); h++) {
            featureCombo.addItem((String) featureSorted.get(h));
        }
        for (int i=0; i < valueSorted.size(); i++) {
            valueCombo.addItem((String) valueSorted.get(i));
        }
    }


    public void chooseFeature() {
	int j = featureCombo.getSelectedIndex() - 1;
        if (j < -1) {
            j = -1;
        }
	System.out.println(j);

	//If the selected feature is not 'all'
	if (j >= 0) {
	    Vector fvd_local = multiply2.getFVD();
	    valueCombo.removeAllItems();

	    //featureCombo.addItem(temp);
	    for (int f=0; f < fvd_local.size(); f++) {
                Feature this_feature = (Feature) fvd_local.get(f);
                String temp = this_feature.feature_name;

		if (temp.equals((String) featureCombo.getSelectedItem())) {
		    Vector sortValues = this_feature.values;
		    Vector sortedValues = alphabetize(sortValues);
		    for (int m=0; m < sortedValues.size(); m++) {
                        valueCombo.addItem(sortedValues.get(m));
                    }
		    valueCombo.addItem("#all");
		    break;
		}
	    }
	}
	else { setDropDown(); }
    }

 public void chooseValue() {
	String currentValue = (String) valueCombo.getSelectedItem();
        Vector fvd_local = multiply2.getFVD();
	if (currentValue.equals("#all")) {
	    int position = textArea.getCaretPosition();
	    String currentFeature = (String) featureCombo.getSelectedItem();
	    String screenText = "(" + currentFeature + " " + currentValue + ")";
	    textArea.insert(screenText, position);
	}
	else {
	    for (int f=0; f < fvd_local.size(); f++) {
		Feature this_feature = (Feature) fvd_local.get(f);
		String temp = this_feature.feature_name;
		//featureCombo.addItem(temp);
		
		for (int g=0; g < this_feature.values.size(); g++) {
		    String valueName = (String) this_feature.values.get(g);
		    if (valueName.equals(currentValue)) {
			int position = textArea.getCaretPosition();
			String screenText = "(" + temp + " " + valueName + ")"; 
			textArea.insert(screenText, position);
		    }
		}
	    }
	}        
    }
}


public class multiplyGUI {


    public static void main (String[] argv)
    {
	//multiply2.load_fvd("fvd_revised.txt");
	multiply2.load_fvd("LDC_features.fvd");
	multiply2.load_restrictions("restriction.rf");
	eGUI makeMyGUI = new eGUI("fvd_revised.txt", "restriction.rf");
    }    

}
