import java.io.*;
import java.util.Vector;
import java.awt.*;
import java.applet.*;
import java.awt.event.*; // Needed for ActionListener.
import java.util.*;
import javax.swing.*;

class FeatureStructure{

    String source_sentence;
    String context;
    String comment;
    StringBuffer feature_structure;
    static Vector Multiply = new Vector();

    public FeatureStructure(StringBuffer fs, String s_s, String c) {
	source_sentence = s_s;
	context = c;
	feature_structure = fs;
	comment = "";
    }

    public FeatureStructure(StringBuffer fs, String s_s, String c, String com) {
        source_sentence = s_s;
        context = c;
        feature_structure = fs;
        comment = com;
    }

    public String getFS() { return feature_structure.toString(); }

    public String getContext() { return context;}

    public String getSource() { return source_sentence;}

    public String getComment() { return comment;}

    public void setContext(String modifiedC) { context = modifiedC;}

    public void setSource(String modifiedS) { source_sentence = modifiedS;}

    public void setComment(String modifiedCom) { comment = modifiedCom;}

    public static void setMultiply(Vector v){
	Multiply = v;
    }

    public String toString() {
	String s = source_sentence + "\n" + context + "\n" + feature_structure; 
	return s;
    }
}

class editGUI extends JFrame implements ActionListener {

    JPanel panel;
    JLabel defaultExLabel, defaultFVDLabel, commentLabel, number_label;
    JTabbedPane tabbedPane = new JTabbedPane();
    JFrame jf3;
    JTextArea textArea1, textArea2, textArea3, textArea4, textArea5;
    String currentFile;

    File currentDirectory = new File("/Volumes/DOCS/Recent Projects");
    String saveName = "";

    JButton next, previous, beginning, end, go;
    JButton yes, no, cancel;
    JScrollPane jp1, jp2, jp3, jp4, jp5;
    boolean loadCheck;  //Whether or not a file has been loaded
    File saveFile;
    static Vector FS_set = new Vector();
    JFileChooser cfchooser;
    String lastSaved = ""; //Keeps track of whether the multiply has been saved
    JTextField src_sent, context, comment;
    JTextField number;
    int actionToTake = 0; /* Keeps track of the action to be taken with the save dialog
                           * 1 = close window
                           * 2 = clear text
                           * 3 = load new text
                           */
    int display_index = 0;
    //String currentFVD =  "feature_spec_LDC.txt";
    //String currentExclusion = "exclusions.txt";
    Vector featureSorted = new Vector();  //Alphabetized list of features
    Vector valueSorted = new Vector(); //Alphabetized list values
    
    public editGUI() {

        //initialize frame components
        JFrame.setDefaultLookAndFeelDecorated(true);
        this.setTitle ("Elicitation Corpus Builder");
        this.setResizable (true);
        this.setSize (700, 700);

        //Add menubar
        JMenuBar menuBar = new JMenuBar();
        this.setJMenuBar(menuBar);

        JMenu file = new JMenu("File");
	menuBar.add(file);

        //**Menu Options
        JMenuItem load = new JMenuItem ("Load Feature Structures");
        load.setMnemonic('L');
        load.addActionListener (this);
        load.setActionCommand("load feature structures");
        file.add(load);
        JMenuItem save = new JMenuItem ("Save Feature Structures");
        save.setMnemonic('S');
        save.addActionListener (this);
        save.setActionCommand("save feature structures");
        file.add(save);
        JMenuItem saveAs = new JMenuItem ("Save FS As");
        saveAs.setMnemonic('V');
        saveAs.addActionListener (this);
        saveAs.setActionCommand("save fs as");
        file.add(saveAs);
        file.addSeparator();
        JMenuItem exit = new JMenuItem ("Exit");
        exit.setMnemonic('E');
        exit.addActionListener (this);
        exit.setActionCommand("exit");
        file.add(exit);

        //Add components to the JFrame
        panel = new JPanel();
        this.getContentPane().add(panel);

        panel.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
        panel.setLayout(new GridLayout(0, 1));

        textArea1 = new JTextArea(6, 30);
        textArea1.setEditable(true);
        textArea1.setLineWrap(true);
        jp1 = new JScrollPane(textArea1);
        jp1.setPreferredSize(new Dimension(600, 500));

	textArea2 = new JTextArea(6, 30);
        textArea2.setEditable(true);
        textArea2.setLineWrap(true);
        jp2 = new JScrollPane(textArea2);
        jp2.setPreferredSize(new Dimension(600, 500));

	textArea3 = new JTextArea(6, 30);
        textArea3.setEditable(false);
        textArea3.setLineWrap(true);
        jp3 = new JScrollPane(textArea3);
        jp3.setPreferredSize(new Dimension(600, 500));

	textArea4 = new JTextArea(6, 30);
        textArea4.setEditable(false);
        textArea4.setLineWrap(true);
        jp4 = new JScrollPane(textArea4);
        jp4.setPreferredSize(new Dimension(600, 500));

	textArea5 = new JTextArea(6, 30);
        textArea5.setEditable(false);
        textArea5.setLineWrap(true);
        jp5 = new JScrollPane(textArea5);
        jp5.setPreferredSize(new Dimension(600, 500));

	tabbedPane = new JTabbedPane();
	tabbedPane.addTab("Filtered", jp5);
        tabbedPane.addTab("Writing", jp1);
        tabbedPane.setSelectedIndex(0);
        tabbedPane.addTab("Checking", jp2);
        tabbedPane.addTab("Pretty Printed", jp3);
        tabbedPane.addTab("Original", jp4);

	Box box1 = Box.createHorizontalBox();
	box1.add(tabbedPane);

	beginning = new JButton("<<");
        beginning.addActionListener (this);
	beginning.setEnabled(false);
	previous = new JButton("<");
        previous.addActionListener (this);
	previous.setEnabled(false);
	next = new JButton(">");
        next.addActionListener (this);
	next.setEnabled(false);
	end = new JButton(">>");
        end.addActionListener (this);
	end.setEnabled(false);

	Dimension d = new Dimension(500, 500);
	number = new JTextField();
	//number.setMaximumSize(d);
	//number.setSize(12, 50);
	number.setColumns(5);
	number.addActionListener(this);
	number.setEnabled(false);
	go = new JButton("Go");
        go.addActionListener(this);
        go.setEnabled(false);


	number_label = new JLabel("  out of:      ");

	Box box2 = Box.createHorizontalBox();
	//box2.add(Box.createGlue());
        box2.add(beginning);
	box2.add(previous);
	//box2.add(Box.createGlue());
	box2.add(go);
	box2.add(number);
	box2.add(number_label);
	//box2.add(Box.createGlue());
        box2.add(next);        
        box2.add(end);
	//box2.add(Box.createGlue());

	JLabel sent_label = new JLabel("Sentence: ");
	src_sent = new JTextField(); 
	JLabel context_label = new JLabel("Context: ");
	context = new JTextField();
	JLabel comment_label = new JLabel("Comment: ");
        comment = new JTextField();

	Box box4 = Box.createVerticalBox();
	box4.add(sent_label);
	box4.add(context_label);
	box4.add(comment_label);

	Box box5 = Box.createVerticalBox();
	box5.add(src_sent);
	box5.add(context);
	box5.add(comment);

	Box box3 = Box.createHorizontalBox();
        box3.add(Box.createGlue());
        box3.add(box4);
        box3.add(box5);
	box3.add(Box.createGlue());       

	Box vertical_box = Box.createVerticalBox();
	vertical_box.add(box1);
	vertical_box.add(box3);
	vertical_box.add(box2);
	panel.add(vertical_box);


	this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

        this.addWindowListener (new WindowAdapter() {
                public void windowClosing(WindowEvent e) { /*System.exit(0);*/
                    //panel.setVisible(true);
                    actionToTake = 1;
                    areYouSurePane();
                }
            });

        getContentPane().add(panel);
        this.setVisible(true);
    }


    /*This pane will ask the user whether they want to save their work
     *before performing an action that will delete the multiply
     */
    public void areYouSurePane() {
	
	//initialize frame components
	jf3 = new JFrame();
	jf3.setTitle ("Save Current Multiply?");
	jf3.setResizable (true);
	jf3.setSize (450, 200);

	JPanel savePanel = new JPanel();
	savePanel.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
	savePanel.setLayout(new GridLayout(0, 1));
	
	//Set up buttons at the bottom for file management
	Box Box2 = Box.createHorizontalBox();
	yes = new JButton("yes");
	yes.addActionListener (this);
	no = new JButton("no");
	no.addActionListener (this);
	cancel = new JButton("cancel");
	cancel.addActionListener (this);
	Box2.add(Box.createGlue());
	Box2.add(yes);
	Box2.add(no);
	Box2.add(cancel);
	Box2.add(Box.createGlue());

	JLabel saveCurrentLabel = new JLabel();
	saveCurrentLabel.setText("Would you like to save the current set?");

	saveCurrentLabel.setHorizontalAlignment(SwingConstants.CENTER);

	//Create Boxes for Contentd
	Box messageBox = Box.createVerticalBox();
	messageBox.add(Box.createGlue());
	messageBox.add(saveCurrentLabel);
	messageBox.add(Box.createGlue());
	messageBox.add(Box2);
	messageBox.add(Box.createGlue());

	savePanel.add(messageBox, "Center");
	
	this.addWindowListener (new WindowAdapter() {
		public void windowClosing(WindowEvent e) { System.exit(0); }
		
	    });
	
	jf3.getContentPane().add(savePanel);
	jf3.setVisible(true);
    
	//else { nextAction(actionToTake); }
    }

    /* The Action listener for the menu and button functions
     */
    public void actionPerformed (ActionEvent e) {
        String command = e.getActionCommand();

        if (command.equals("cancel")) { jf3.setVisible(false); this.setVisible(true); }
        else if (command.equals("yes")) {
            jf3.setVisible(false);
	    set_sent_and_context(display_index);
            String saveName = saveDialog();
            if (saveName != ""){
		//SAVE WHOLE SERIES
                save(saveName);
                nextAction(actionToTake);
            }
        }
        else if (command.equals("no")) {
            jf3.setVisible(false);
            nextAction(actionToTake);
        }
        else if (command.equals("exit")) {
            actionToTake = 1;
            areYouSurePane();
        }
        //else if (command.equals("cut")) { textArea.cut(); }
        //else if (command.equals("paste")) { textArea.paste(); }
        //else if (command.equals("copy")) { textArea.copy(); }
        else if (command.equals("about")){
            JOptionPane.showMessageDialog(this, "This software was designed for the MILE \n" +
                                           "elicitation project at Carnegie Mellon Univeristy." +
                                          "\n\nEmail any problems to nosila@cs.cmu.edu");
        }
        //else if (command.equalsIgnoreCase("Save Feature Structures")) {
        //    String saveName = saveDialog();

	//     if (saveName != null){ save(saveName); }
        //}
	else if (command.equalsIgnoreCase("<<")) {
	    set_sent_and_context(display_index);
            display_index = 0;
            display(display_index);
        }
	else if (command.equalsIgnoreCase("<")) {
	    set_sent_and_context(display_index);
            display_index--;
            display(display_index);
        }
	else if (command.equalsIgnoreCase(">")) {
	    set_sent_and_context(display_index);
	    display_index++;
	    display(display_index);
	}
	else if (command.equalsIgnoreCase(">>")) {
	    set_sent_and_context(display_index);
            display_index = FS_set.size() -1;
            display(display_index);
        }
	else if (command.equalsIgnoreCase("Go")) {
	    if (kosher(number.getText())) {
		Integer I = Integer.valueOf(number.getText().trim());
		int i = I.intValue();
		set_sent_and_context(display_index);
		display_index = i-1;
		display(display_index);
	    }
        }
        else if (command.equalsIgnoreCase("load feature structures")) {
            actionToTake = 3;
	    display_index = 0;
            if (FS_set.size() > 0) { areYouSurePane(); }
	    else { nextAction(actionToTake); }
            //lastSaved = textArea.getText();
        }
        else if (command.equalsIgnoreCase("save feature structures")) {
            System.out.println("Saved: " + saveName);
	    set_sent_and_context(display_index);
            if (saveName != ""){
		//SAVE WHOLE SERIES
                save(saveName);
            }
            else {
		String  nextSaveName = saveDialog();
		set_sent_and_context(display_index);
                if (nextSaveName != ""){
		    //SAVE WHOLE SERIES
                    save(saveName);
		    saveName = nextSaveName;
                    //lastSaved = textArea.getText();
                }
            }
        }
        else if (command.equalsIgnoreCase("save fs as")) {
            String nextSaveName = saveDialog();
	    set_sent_and_context(display_index);
            if (nextSaveName != ""){
		//SAVE WHOLE SERIES
                save(nextSaveName);
		saveName = nextSaveName;
                //lastSaved = textArea.getText();
            }
        }
    }

    private void display(int current_index) {

	FeatureStructure fs = (FeatureStructure) FS_set.get(current_index);
        textArea1.setText(Format.space(fs.getFS()));
	System.out.println("****\n" + fs.getFS());
        textArea2.setText(Format.group(fs.getFS()));
	textArea3.setText(Format.prettyPrint(fs.getFS()));
	textArea4.setText(fs.getFS());
	textArea5.setText(Format.filter(fs.getFS()));
	context.setText(fs.getContext());
	src_sent.setText(fs.getSource());
	comment.setText(fs.getComment());
	number.setText((current_index + 1) + "");
	number_label.setText("  out of: " + FS_set.size() + "  ");


	System.out.println("Index: " + current_index + " Size: " + FS_set.size());
	
	if (FS_set.size() == 1) {
	    beginning.setEnabled(false);
            previous.setEnabled(false);
            next.setEnabled(false);
            end.setEnabled(false);
	}
	else if (current_index == 0) {
	    beginning.setEnabled(false);
	    previous.setEnabled(false);
	    next.setEnabled(true);
	    end.setEnabled(true);
	    number.setEnabled(true);
	    go.setEnabled(true);
	}
	else if (current_index == (FS_set.size()-1)){
	    beginning.setEnabled(true);
            previous.setEnabled(true);
            next.setEnabled(false);
            end.setEnabled(false);
	    number.setEnabled(true);
	    go.setEnabled(true);
	}
	else {
	    beginning.setEnabled(true);
            previous.setEnabled(true);
            next.setEnabled(true);
            end.setEnabled(true);
	    number.setEnabled(true);
	    go.setEnabled(true);
	}
    }


    private boolean kosher (String toCheck) {
	boolean ok = true;
	char[] digit_check = toCheck.toCharArray();
	//if not a number
	for (int a = 0; a < digit_check.length; a++) {
	    System.out.println(digit_check[a]);
	    ok = Character.isDigit(digit_check[a]);
	    if (!ok) {
		System.out.println("NOT A NUMBER"); 
		break;
	    }
	}
	if (ok) {
	    Integer I = Integer.valueOf(number.getText().trim());
	    int i = I.intValue();
	    //if zero or less
	    if (i <= 0) { ok = false; System.out.println("ZERO OR LESS");}
	    //if greater than total
	    if (i > FS_set.size()) { ok = false;  System.out.println("NUMBER TOO BIG");}
	}
	return ok;
    }

    private void set_sent_and_context(int modify_index) {
	FeatureStructure to_modify = (FeatureStructure) FS_set.get(modify_index);
	to_modify.setContext(context.getText());
        to_modify.setSource(src_sent.getText());
	to_modify.setComment(comment.getText());
    }

    /*Continues a selected action after unsaved data inquiries have been made
     * 1 = close window
     * 2 = clear text
     * 3 = load new text
     */
    private void nextAction(int actionToTake) {
        this.setVisible(true);
        if (actionToTake == 1) {
            System.exit(0);
        }
        else if (actionToTake == 3) {
            String loadName = loadDialog();
            Vector v = new Vector();
	    
	    if (loadName != ""){
		saveName = loadName;
                v = load_generic(loadName);
		load_fs(v);
		if (FS_set.size() > 0) { display(0); }
		System.out.println("Load: " + saveName);
            }
        }
    }


    private static void save(String filename){
        try {
            FileWriter fr = new FileWriter (filename, false);
            PrintWriter pw = new PrintWriter (fr, true);
            pw.println("*** START MULTIPLY ***");
	    
	    for (int a=0; a < FeatureStructure.Multiply.size(); a++) {
		pw.println(FeatureStructure.Multiply.get(a).toString());
	    }
	    pw.println("*** END MULTIPLY ***");
	    pw.println();

	    //print each feature structure
	    for (int b=0; b < FS_set.size(); b++) {
		FeatureStructure fs = (FeatureStructure) FS_set.get(b);
		pw.println("newpair");
		pw.println("srcsent: " + fs.getSource());
		pw.println("tgtsent:");
		pw.println("aligned:");
		pw.println("context: " + fs.getContext());
		pw.println("comment: " + fs.getComment());
		pw.println();
		pw.println(fs.getFS());
		pw.println();
	    }
	    pw.close();
        }
        catch (IOException e) {
            System.out.println ("Cannot open file");
        }
    }

    //Loads a generic file
    public static Vector load_generic(String filename) {
        Vector read_in = new Vector();

        try{

            //Open file for reading
            FileReader fr = new FileReader (filename);
            LineNumberReader lr = new LineNumberReader (fr);

            int lineCount = 0;  //The counter for lines
            boolean eof = false;  //End of File Flag

            //Read file line by line
            while (!eof){
                //read line to string
                String line = lr.readLine();

                if (line == null){
                    eof = true;
                }
                else {
                    read_in.add(line);
                }
            }
	}
        catch (IOException e) {
            System.out.println ("Cannot open file!! " + e);
            System.exit(0);

        }
        return read_in;
    }

    private static void load_fs(Vector lines) {

	int count = 0;
	FS_set = new Vector();
	String fs_context = "";
	String fs_sentence = "";
	String fs_comment = "";

	String current_line = (String) lines.get(count);

	while (count < lines.size()) {
	    //System.out.println(current_line);
	    //store attached multiply
	    if ((current_line.indexOf("START MULTIPLY") > -1)) {
		Vector multiply_vector = new Vector();
		count++;
		current_line = (String) lines.get(count);
		while((current_line.indexOf("END MULTIPLY") == -1)){
		    multiply_vector.add(current_line);
		    count++;
		    current_line = (String) lines.get(count);
		}
    

		FeatureStructure.setMultiply(multiply_vector);
	    }
	    

	    //read in context & sentence
	    if (current_line.indexOf("context:") > -1) {
		if (current_line.indexOf(" ") > -1) { 
		    fs_context = current_line.substring(current_line.indexOf(" "), current_line.length());
		    fs_context = fs_context.trim();
		}
	    }
	    if (current_line.indexOf("comment:") > -1) {
                if (current_line.indexOf(" ") > -1) {
		    fs_comment = current_line.substring(current_line.indexOf(" "), current_line.length());
		    fs_comment = fs_comment.trim();
		}
            }
	    else if (current_line.indexOf("srcsent:") > -1) {
		if (current_line.indexOf(" ") > -1) {
		    fs_sentence = current_line.substring(current_line.indexOf(" "), current_line.length());
		    fs_sentence = fs_sentence.trim();
		}
            }
	    //read in feature structure
	    else if (current_line.indexOf("((") == 0) {
		StringBuffer fs = new StringBuffer();
		String tempString = "";
		while((!current_line.equals("")) && (count < lines.size())){
		    //fs.append(current_line);
		    tempString = tempString + current_line;
		    count++;
		    if (count < lines.size()) {
			current_line = (String) lines.get(count);
		    }
		}
		//make a new feature_strucuture
		fs = new StringBuffer(tempString);
		FeatureStructure next_one;
		if (fs_comment.equals("")) {
		    next_one = new FeatureStructure(fs, fs_sentence, fs_context);
		}
		else {
		    next_one = new FeatureStructure(fs, fs_sentence, fs_context, fs_comment);
		}
		FS_set.add(next_one);
		System.out.println(next_one);
		System.out.println("Size: " + FS_set.size());
		fs_comment = ""; 
	    }
	    
	    count++;
	    if (count < lines.size()) {	current_line = (String) lines.get(count); }
	}
    }

    private String saveDialog() {
        String saveName = "";
        //The following code has been donated by Erik Peterson and
        //modified by Alison Alvarez
        cfchooser = new JFileChooser();
        cfchooser.setCurrentDirectory(currentDirectory);
        int retVal = cfchooser.showSaveDialog(this);
        if (retVal == JFileChooser.APPROVE_OPTION) {
            saveFile = cfchooser.getSelectedFile();
            saveName = saveFile.getPath();
        }
        return saveName;
    }

    private String loadDialog() {
        String loadName = "";
        File loadFile;

        //The following code has been donated by Erik Peterson and
        //modified by Alison Alvarez
        JFileChooser loadChooser = new JFileChooser();
	//ExampleFileFilter filter = new ExampleFileFilter();
	//filter.addExtension("txt");
	//filter.setDescription("FS Text Files");
	//loadChooser.setFileFilter(filter);
        loadChooser.setCurrentDirectory(currentDirectory);
        int retVal = loadChooser.showOpenDialog(this);
        if (retVal == JFileChooser.APPROVE_OPTION) {
            loadFile = loadChooser.getSelectedFile();
            loadName = loadFile.getPath();
        }
        return loadName;
    }

}
 
class sentence_editor {


	public static void main (String[] argv)
	{
	    editGUI makeMyGUI = new editGUI();
	}

}

